/*
 * Copyright 2011 Raster Software Vigo
 *
 * This file is part of ttos
 *
 * ttos is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * ttos is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * fonts.h
 *
 *  Created on: 22/10/2010
 *      Author: raster
 */

#ifndef FONTS_H_
#define FONTS_H_

#include <sys/types.h>
#include "bitmaps.h"

#define TTOS_FONT_LINE_SEP 2

struct _font_base {

	int fd;
	int8_t *path;
	uint8_t *data;
	uint8_t *glyphs;
	size_t size;
	uint32_t *offsets;
	uint32_t first_glyph;
	uint32_t last_glyph;
	uint8_t average_height;

	uint16_t colors[256];
	uint8_t r,g,b;
};

struct _font_data {

	uint8_t width;
	uint8_t height;
	int8_t addx;
	int8_t addy;
	int8_t incx;
	int8_t incy;

};

struct _font_base *fonts_init(int8_t *font_path);
void fonts_destroy(struct _font_base *object);
void fonts_set_color_table(struct _font_base *font, struct ttos_color *color);
int32_t fonts_render_glyph(struct _font_base *font,TTOS_Surface *surface,int32_t x, int32_t y,uint32_t glyph,struct _font_data *font_data);
TTOS_Surface *fonts_render_line(struct _font_base *font, Cstring *text, uint32_t flags, uint32_t d_width, struct ttos_color *color);
TTOS_Surface *fonts_render_label(struct _font_base *font, Cstring text, uint32_t flags, uint32_t width, struct ttos_color *color);
#endif /* FONTS_H_ */
